package org.supermmx.ginger.gui.action;

import org.supermmx.ginger.Ginger;
import org.supermmx.ginger.GingerDestination;
import org.supermmx.ginger.GingerSession;
import org.supermmx.ginger.gui.dialog.QuickConnectDialog;

import org.supermmx.peony.ui.PeonyAction;
import org.supermmx.peony.ui.PeonyUIData;

import java.awt.event.ActionEvent;

/**
 * Quick connect.
 *
 * @author SuperMMX
 */
public class QuickConnectAction extends PeonyAction {
    private QuickConnectDialog dialog;

    public QuickConnectAction(PeonyUIData data, QuickConnectDialog dialog) {
        super(data);

        this.dialog = dialog;

        setName(i18n.tr("&Connect"));
    }

    public void actionPerformed(ActionEvent event) {
        Ginger ginger = (Ginger)data;

        String host = dialog.getHost();
        int port = dialog.getPort();

        GingerDestination dest = new GingerDestination(host, port);
        GingerSession session = new GingerSession(dest);

        ginger.getFrame().addSession(session);

        session.connect();

        dialog.dispose();
    }
}
