package org.supermmx.ginger.gui.dialog;

import org.supermmx.ginger.Ginger;
import org.supermmx.ginger.gui.action.QuickConnectAction;

import org.supermmx.peony.ui.PeonyDialog;
import org.supermmx.peony.ui.PeonyDialogCloseAction;

import java.awt.BorderLayout;
import java.awt.Dialog;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.SwingUtilities;
import javax.swing.text.BadLocationException;
import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyleContext;
import javax.swing.text.StyledDocument;

/**
 * About dialog.
 *
 * @author SuperMMX
 */
public class AboutDialog extends PeonyDialog {

    public AboutDialog(Ginger ginger) {
        super(ginger, ginger.getFrame());
    }

    protected void createUI() {
        Ginger ginger = (Ginger)data;

        setModalityType(Dialog.DEFAULT_MODALITY_TYPE);
        setTitle(i18n.tr("About"));

        // content
        DefaultStyledDocument doc = new DefaultStyledDocument();

        // Insert content
        try {
            // Version
            SimpleAttributeSet largeBoldAttr = new SimpleAttributeSet();
            StyleConstants.setBold(largeBoldAttr, true);
            StyleConstants.setFontSize(largeBoldAttr, 16);

            doc.insertString(doc.getLength(),
                             i18n.tr("Ginger {0}\n", ginger.getVersion()),
                             largeBoldAttr);

            // revno
            SimpleAttributeSet normalAttr = new SimpleAttributeSet();
            doc.insertString(doc.getLength(),
                             i18n.tr("Revision Number: {0}\n", ginger.getRevisionNumber()),
                             normalAttr);

            // revid
            doc.insertString(doc.getLength(),
                             i18n.tr("Revision ID: {0}\n", ginger.getRevisionID()),
                             normalAttr);
            
        } catch (BadLocationException badLocationException) {
        }

        JTextPane textPane = new JTextPane(doc);
        textPane.setEditable(false);
        JScrollPane scrollPane = new JScrollPane(textPane);

        getContentPane().add(scrollPane);

        // Button panel
        JPanel buttonPanel = new JPanel();
        final JButton closeButton =
            new JButton(new PeonyDialogCloseAction(this, i18n.tr("&Close")));

        buttonPanel.add(closeButton);

        getContentPane().add(buttonPanel, BorderLayout.SOUTH);

        SwingUtilities.invokeLater(new Runnable() {  
                public void run() {  
                    closeButton.requestFocusInWindow();
                }
            });

        setSize(450, 300);

        super.createUI();

        setVisible(true);
    }
}
