package org.supermmx.ginger.gui.dialog;

import org.supermmx.ginger.Ginger;
import org.supermmx.ginger.gui.action.QuickConnectAction;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory; 

import org.supermmx.peony.ui.PeonyDialog;
import org.supermmx.peony.ui.PeonyDialogCloseAction;

import java.awt.BorderLayout;
import java.awt.Dialog;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JLabel;

/**
 * Quick connect dialog.
 *
 * @author SuperMMX
 */
public class QuickConnectDialog extends PeonyDialog {
    private static Log log = LogFactory.getLog(QuickConnectDialog.class);

    private JTextField hostField;
    private JTextField portField;

    public QuickConnectDialog(Ginger ginger) {
        super(ginger, ginger.getFrame());
    }

    public String getHost() {
        return hostField.getText();
    }

    public int getPort() {
        int res = 23;
        try {
            res = Integer.parseInt(portField.getText());
        } catch (Exception e) {
            log.error(i18n.tr("Port should be an integer!"));
        }

        return res;
    }

    protected void createUI() {
        setModalityType(Dialog.DEFAULT_MODALITY_TYPE);
        setTitle(i18n.tr("Quick Connect"));

        JPanel contentPanel = new JPanel();

        hostField = new JTextField(15);
        portField = new JTextField(5);
        portField.setText("23");

        contentPanel.add(new JLabel(i18n.tr("Host:")));
        contentPanel.add(hostField);
        contentPanel.add(new JLabel(i18n.tr(":")));
        contentPanel.add(portField);

        getContentPane().add(contentPanel);

        JButton connectButton = new JButton(new QuickConnectAction(data, this));
        JButton cancelButton =
            new JButton(new PeonyDialogCloseAction(this, i18n.tr("Canc&el")));

        JPanel buttonPanel = new JPanel();
        buttonPanel.add(connectButton);
        buttonPanel.add(cancelButton);

        // default button, input ENTER in text fields
        getRootPane().setDefaultButton(connectButton);

        getContentPane().add(buttonPanel, BorderLayout.SOUTH);

        pack();

        super.createUI();

        setVisible(true);
    }
}
