package org.supermmx.ginger.document;

import static org.supermmx.ginger.document.GingerAttribute.*;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 * Test cases for GingerAttribute.
 *
 * @author SuperMMX
 */
public class GingerAttributeTest {
    /**
     * Create the attribute from int array
     */
    @Test
    public void testCreateInt() {
        GingerAttribute expectAttr = new GingerAttribute();
        expectAttr.setForeground(RED);
        expectAttr.setBackground(BLUE);
        expectAttr.setBold(true);
        expectAttr.setUnderscored(true);
        expectAttr.setBlinking(true);
        expectAttr.setReversed(true);

        GingerAttribute attr = GingerAttribute.createAttribute(RED + FG_START, BLUE + BG_START, BOLD, UNDERSCORED, BLINKING, REVERSED);

        assertEquals(expectAttr, attr);
    }

    /**
     * Create the attribute from string
     */
    @Test
    public void testCreateString() {
        GingerAttribute expectAttr = new GingerAttribute();
        expectAttr.setForeground(RED);
        expectAttr.setUnderscored(true);
        expectAttr.setBlinking(true);

        GingerAttribute attr = GingerAttribute.createAttribute("4;5;31");

        assertEquals(expectAttr, attr);
    }
}
